10  REM   TRACK.BAS by Geoff Landis
20  REM   from the 9/83 "Model Rocketeer", page 11
30  REM   NAR Tracking Data Reduction by Various Methods
40  REM   Refer to that issue for full details.
50  REM
60  REM   Tracking Data Reduction Program
70  REM   Program Copyright (C) 1983
80  REM   by Geoffrey A. Landis
90  REM   May be freely used, but not sold.
100 REM
110 REM   Minor Edits and Renumbering Copyright (C) 1985 Robert G. Kaplow
120 REM   
130 REM   Variable Baseline Input And Other Changes
140 REM   Copyright (C) 1988 NAR Contest Board
150 REM
160 REM   This program is approved for use in reducing
170 REM   altitude data at NAR sanctioned contests.
180 REM   Mark B. Bundick, Chairman
190 REM   NAR National Contest Board
200 REM   July 1, 1988
210 REM
220 'DEF FNT (Z9) = SIN(Z9)/COS(Z9)
230 'DEF FNT (Z8) = ATN(SQR(1-Z8^2)/Z8)
240 'DEF FNT (Z7) = COS(Z7)/SIN(Z7)
250 REM
260 REM Begin Data Input
270 REM
280 PRINT "Input your baseline length."
290 INPUT B
300 IF B <=0 then GOTO 280
310 P1 = 3.14159265358696
320 R1 = .0174532925199433
330 PRINT
340 INPUT "Tracker One Azimuth  : ";A1
350 INPUT "            Elevation: ";E1
360 IF E1 < 0 THEN 810
370 PRINT
380 INPUT "Tracker Two Azimuth  : ";A2
390 INPUT "            Elevation: ";E2
400 IF E2 < 0 THEN 810
410 A1 = A1 * R1
420 A2 = A2 * R1
430 E1 = E1 * R1
440 E2 = E2 * R1
450 REM
460 REM   Geodesic Data Reduction
470 REM
480 F = SIN(E1)*SIN(E2)-COS(E1)*COS(E2)*(COS(A1)*COS(A2)-SIN(A1)*SIN(A2))
490 D = 1 - F ^ 2
500 T = (COS(E2)*SIN(E1)*SIN(A2)-COS(E1)*SIN(E2)*SIN(A1))/SQR(D)
510 D1 = (COS(E1)*COS(A1) + F*COS(E2)*COS(A2))/D
520 D2 = (COS(E2)*COS(A2) + F*COS(E1)*COS(A1))/D
530 A = B*(SIN(E1)+SIN(E2)) * (D1*D2)/(D1+D2)
540 C = ABS(T*B/A)*100
550 'PRINT
560 PRINT "Geodesic"
570 GOSUB 710
580 REM
590 REM   Vertical Midpoint Data Reduction (Classic NAR Method)
600 REM
610 S = SIN(A1+A2)
620 H1 = SIN(A2)*SIN(E1)/(S*COS(E1))
630 H2 = SIN(A1)*SIN(E2)/(S*COS(E2))
640 A = B*(H1+H2)/2
650 C = ABS((H1-H2)/(H1+H2))*100
660 'PRINT
670 PRINT "Vertical Midpoint"
680 GOSUB 710
690 REM
700 GOTO 330
710 REM
720 REM    Display Altitude and Closure
730 REM
740 PRINT "Altitude: ";A
750 IF C > 10 THEN GOTO 790
760 IF A < 1 THEN GOTO 790
770 PRINT "Track Closed: "; C; "%"
780 RETURN
790 PRINT "Track Not Closed: "; C; "%"
800 RETURN
810 END
820 END
