REM
REM   GARDEN PLANNING PROGRAM
REM
REM    written by Ted Batutis
REM            for  The Good Earth SIG
REM             on  CompuServe Information Service
REM
REM    Modified by Kevin Andrews
REM            for the Atari Portfolio
REM            August 22nd, 1991
REM
REM    Copyright 1982 by Ted Batutis
REM    ALL COMMERCIAL RIGHTS RESERVED
REM
REM    Feel free to distribute this program
REM    (as long as you don't charge for it!)
REM
REM    This program was tested on a 1.07 ROM
REM    running on a 128k ram card with a 15k
REM    C: drive
REM
REM    It was running well using PBASIC 4.6 and 4.7
REM    the SSIZE command may need to be removed if
REM    running older versions of PBASIC
REM
REM    NOTE: you'll likely want to run SPB to remove remarks
REM
SSIZE=40
GOSUB 400
CLS
?"***************************"
?"* Garden Planning Program *"
?"***************************"
?:?:input "Need directions (Y/N)?  ",A$
IF A$="Y"OR A$="y"THEN GOSUB 300
REM start of program
100CLS
mc=menu(1,1,6,0,0,23,"Choose Crop (or ESC)",c$(1),c$(2),c$(3),c$(4),c$(5),c$(6),c$(7),c$(8),c$(9),c$(10),c$(11),c$(12),c$(13),c$(14),c$(15),c$(16),c$(17),c$(18),c$(19),c$(20),c$(21),c$(22),c$(23))
IF mc<=(-1)THEN CLS:?"Good Gardening!":END
a=mc%256+1
REM next line is left as a refernce
REM IF A<1OR A>23THEN BEEP:?"Invalid choice":GOTO 100
CLS
?"You have chosen ";C$(A)
INPUT"How many feet of row to plant?  ",F
CLS
?"Here's the information for ";
? F;" feet of"
? C$(A)
F=F/10:Y2=INT(Y(A)*F+.5)
?"Approximate yield is ";Y2;" ";U$(A);" at a"
?"spacing of ";S$(A);" inches between plants."
IF A=16THEN ?"You will need ";INT((O(16)*F)/16);" lbs. of potato":?"seed pieces.":?:GOTO 210
O2=O(A)*F
IF O2<.015625THEN O2$="less than 1/64":GOTO 200
IF O2>=.015625AND O2<.03125THEN O2$="between 1/64 and 1/32":GOTO 200
IF O2>=.03125AND O2<.0625THEN O2$="between 1/32 and 1/16":GOTO 200
IF O2>=.0625AND O2<.125THEN O2$="between 1/16 and 1/8":GOTO 200
IF O2>=.125AND O2<.25THEN O2$="between 1/8 and 1/4":GOTO 200
IF O2>=.25AND O2<.5THEN O2$="between 1/4 AND 1/2":GOTO 200
IF O2>=.5AND O2<1.01THEN O2$="between 1/2 AND 1":GOTO 200
O2=INT(O2+.5):?"You will need about ";O2;" ounces "
IF A=13THEN ?"of onion sets.":?:GOTO 210 ELSE ?"of seed.":?:GOTO 210
200?"You will need ";O2$:?"ounces of";:IF A=13THEN ?" onion sets."ELSE ?" seeds."
210INPUT "[RETURN] for more ...",WT$
CLS
?"Fertilizer rates for:":? (F*10);" feet of ";C$(A):?
?"* Manure (approximate): ";
F3=INT(F1(A)*F+.5):? F3;:?" lbs."
?"* Chemical  (10-10-10): ";
F4=INT((F2(A)*F)*10+.5):F4=F4/10:? F4;:?" cups."
?:INPUT"Hit [RETURN] --->",WT$:GOTO 100
END
REM INSTRUCTIONS
300CLS
?"This program is designed to help you in"
?"planning and planting your garden.  You"
?"will be shown a list of crops.  Pick"
?"one of them by number.  You will then"
?"be asked how many feet of row that you"
?"might be planning to plant of that crop"
?"The program will then tell you how much"
INPUT"[RETURN] for more ...",WT$
CLS
?"yield you can expect, how much seed you"
?"should buy and about how much fertil-"
?"izer to use. Fertilizer rates will"
?"be given in terms of pounds of manure"
?"per row and cups of of 10-10-10 (a"
?"common garden chemical fertilizer"
?"mixture)."
INPUT"[RETURN] for more ...",WT$
CLS
?"One word of warning: Different soils"
?"need different amounts of fertilizer to"
?"give the best yield.  For instance,"
?"sandy soils require more fertilizer"
?"than clayey soils with silty soils in"
?"between. The rates given will be for"
?"the average type of soil. You should"
INPUT"[RETURN] for more ...",WT$
CLS
?"judge on your own how much more or less"
?"you should use in your own garden."
?"Also, the fertilizer value of manure"
?"varies widely depending on source and"
?"how it has been handled. Experience is"
?"the very best teacher in these regards."
?"Good gardening!"
INPUT"Hit [RETURN] key --->",WT$
CLS
RETURN
REM data section
REM If you would like to customize this program
REM by adding your favorite crops or changing the
REM fertilizer rates, etc., this is where you do it.
REM The first set of data is the crop names.  Note that they
REM are in the same order as the crop menu.  If you add more
REM crops, you'll have to re-dimension the appropriate variables,
REM change the menu section and initialization section.
DATA"Snap Beans","Pole Beans","Lima Beans","Beets","Broccoli","Cabbage","Carrots"
DATA"Corn","Cucumbers","Eggplant","Lettuce","Muskmelons","Onions","Peas","Peppers"
DATA"Potatoes","Pumpkins","Radished","Spinach","Summer Squash","Winter Squash"
DATA"Tomatoes","Watermelons"
REM Next comes the data for wt of seed required per 10 feet of row in oz.
REM the assumption is that you plant 3X recommended density then thin
DATA 1.6,1.0,4,.16,.02,.006,.0072,.264,.027,.006,.005,.01286,10,4
DATA.006,35,.0343,.144,.048,.018,.27,.005,.06
REM the next set of data statements refers to the spacing for each of
REM the above crops in inches.
DATA"2-4","4-6","4-6","2-3","18-24","12-18","1-3","10-12","12-15","18-24"
DATA"12","36-48","2-4"
DATA"2-3","18-24","8-10","60-90","1","2-4","18-24","36-48","18-24","60-90"
REM next are the data for yield per 10 foot of row
DATA 12,15,4,15,10,15,10,12,12,10,9,11,10,1.5,6,25,15,3.5,4.5,15,15,25,8
REM Next are the data for the units of the above
DATA"LBS.","LBS.","LBS.","LBS.","LBS.","LBS.","LBS.","EARS","LBS.","LBS.","HEADS","FRUITS"
DATA"LBS.","PINTS","LBS.","LBS.","LBS.","LBS.","LBS.","LBS.","LBS.","LBS.","FRUIT"
REM Here are the fertilizer rates for a ten foot row in terms of manure
REM in lbs.
DATA 04,04,04,15,12,12,10,15,10,10,10,10,15,05,12,20,10,10,15,10,10,10,10
REM Here are the fertilizer rates for a 10-10-10 chemical fertilizer
REM formulation (for a ten foot row as well) in cups
DATA.25,.25,.25,.5,.5,.5,.5,.5,.5,.5,.5,.5,.5,.25,.5,.5,.5,.5,.3,.5,.5,.5,.5
REM INITIALIZATION
400DIM C$(23),O(23),S$(23),Y(23),U$(23),F1(23),F2(23)
REM The variables are CROP, OUNCES,SPACING,YIELD, UNITS, FERTILIZER RATE
REM for MANURE (1) and 10-15-10 (2)
FOR I=1TO 23:READ C$(I):NEXT I
FOR I=1TO 23:READ O(I):NEXT I
FOR I=1TO 23:READ S$(I):NEXT I
FOR I=1TO 23:READ Y(I):NEXT I
FOR I=1TO 23:READ U$(I):NEXT I
FOR I=1TO 23:READ F1(I):NEXT I
FOR I=1TO 23:READ F2(I):NEXT I
RETURN

